## boinc-app-eah-brp 0.20170426%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to compile with gcc-snapshot.
#export  CC=/usr/lib/gcc-snapshot/bin/gcc
#export CXX=/usr/lib/gcc-snapshot/bin/g++
#export CPP=/usr/lib/gcc-snapshot/bin/cpp

# Uncomment for particular version of gcc
#export  CC := gcc-4.7
#export CXX := g++-4.7
#export CPP := cpp-4.7
export  CC := gcc-5
export CXX := g++-5
export CPP := cpp-5

# Uncomment for clang (llvm)
#export CC  = clang
#export CXX = clang

# Set default flags with dpkg-buildflags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_TARGET_GNU_CPU  ?= $(shell dpkg-architecture -qDEB_TARGET_GNU_CPU)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_TARGET_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_TARGET_GNU_TYPE)

DEBIAN_VERSION ?= $(shell head -n 1 debian/changelog | cut -f2 -d\( | cut -f1 -d\) )

$(info DEB_TARGET_GNU_CPU: $(DEB_TARGET_GNU_CPU))
$(info DEB_TARGET_GNU_TYPE: $(DEB_TARGET_GNU_TYPE))
$(info DEBIAN_VERSION: $(DEBIAN_VERSION))


# PKG = boinc-app-eah-brp

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

$(info I: Initial settings of compiler flags)
$(info CPPFLAGS: $(CPPFLAGS))
$(info CXXFLAGS: $(CXXFLAGS))
$(info LDFLAGS: $(LDFLAGS))

export EINSTEIN_RADIO_SRC := $(CURDIR)
export EINSTEINBINARY_TARGET = einsteinbinary_BRP4
export EINSTEINBINARY_TARGET_OPENCL = einsteinbinary_BRP4_opencl

# Uncomment this to enable compilation with UltraSPARC specific compiler
# flags. This will most probably increase the application's performance or if
# your are unlucky will break it.
#
#CPUTYPE = $(shell head -1 /proc/cpuinfo | cut -f 2 -d ':' | cut -f 3 -d '\' )
#ifeq (UltraSparc, $(CPUTYPE))
#  CPUSUBTYPE = $(shell head -1 /proc/cpuinfo | cut -f 2 -d ':' | \
#    cut -f 4 -d '\' | cut -f 1 -d '+')
#  CFLAGS += -mcpu=v9
#  CXXFLAGS += -mcpu=v9
#  ifeq (III, $(CPUSUBTYPE))
#    CFLAGS += -mcpu=ultrasparc3
#    CXXFLAGS += -mcpu=ultrasparc3
#  else
#    CFLAGS += -mcpu=ultrasparc
#    CXXFLAGS += -mcpu=ultrasparc
#  endif
#  CFLAGS += -m64
#  CXXFLAGS += -m64
#  DEB_CONFIGURE_EXTRA_FLAGS += --enable-bitness=64
#endif

CFLAGS_APPEND += -std=c++11 # because of UChar, may not be implicitly set for earlier compiler verions
CFLAGS_APPEND += $(CPPFLAGS)


ifeq (g++-5,$(CXX))
WHICH_GPP5 := $(shell which g++-5)
ifeq (,$(WHICH_GPP5))
$(info default g++-5 not available, falling back to g++)
CXX=g++
CC=gcc
CPP=cpp
endif
endif



# Append this to CFLAGS and CXXFLAGS.
CFLAGS_APPEND += -I/usr/include/boinc -I/usr/include/boinc/lib -I/usr/include/boinc/api
CXX_VERSION_LONG=$(shell $(CXX) --version|head -n 1)

ifneq (clang,$(CXX))
GCCVERSION=$(shell $(CXX) --version | tr " " "\n" | egrep '^[0-9]+\.[0-9]+\.[0-9]+$$' | cut -f1,2 -d.)
CFLAGS_APPEND += -O3
#CFLAGS_APPEND += -mno-avx
#CFLAGS_APPEND += -msse4.2
endif

ifeq (clang,$(CXX))
GCCVERSION=$(shell $(CXX) --version | tr " " "\n" | egrep '^[0-9]+\.[0-9]+-[0-9]+$$' | cut -f1 -d-)
CFLAGS_APPEND += -O3
# -O4 implies link-time optimisation with clang, fails
endif

ifeq (linux,$(DEB_TARGET_ARCH_OS))
ifneq (,$(findstring local,$(DEB_BUILD_OPTIONS)))
LOCALOPTIMISATION="yes"
endif
ifeq (,$(shell dpkg-parsechangelog | egrep '^Distribution:' |egrep -v 'UNRELEASED'))
LOCALOPTIMISATION="yes"
endif
endif


#CFLAGS_APPEND += -O3
#CFLAGS_APPEND += -fomit-frame-pointer

# If the package is not meant to be distributed to main servers, then maximise optimisation
ifneq (,$(LOCALOPTIMISATION))
  $(info I: Setting native flags for optimisation)
  CFLAGS_APPEND += -march=native -mtune=native
else
  $(info W: _Not_ setting native flags for optimisation)
ifeq ($(DEB_TARGET_GNU_CPU),i686)
  $(info W: Not supporting earlier systems than i686)
  # Demand i686 class system
  CFLAGS_APPEND += -march=i686 -mtune=i686
  CFLAGS_APPEND += -mfpmath=sse -msse
endif
ifeq ($(DEB_TARGET_GNU_CPU),x86_64)
  #CFLAGS_APPEND += -mavx -msse3 
  CFLAGS_APPEND += -mfpmath=sse -msse
endif
endif

ifeq (1,$(shell $(CXX) --version | egrep -c "g\+\+.* [5678]\.[0-9]\.[0-9]"))
#$(info I: Enabled link-time optimisation for g++ >= 5)
#CFLAGS_APPEND += -flto
endif

CFLAGS_APPEND += -DNOCHECKPOINTING

# 250fold reduction of progress communication, effectively every 2 minutes
CFLAGS_APPEND += -DCOMMUNICATIONREDUCTION=250


DEB_TARGET_ARCH_OS=$(shell dpkg-architecture -qDEB_TARGET_ARCH_OS)
CXXFLAGS += $(CFLAGS_APPEND)

CXXFLAGS += -DDEBIAN_VERSION="\"$(DEBIAN_VERSION)\""
CXXFLAGS += -DDEB_TARGET_ARCH_OS="\"$(DEB_TARGET_ARCH_OS)\""
CXXFLAGS += -DDEB_TARGET_GNU_CPU="\"$(DEB_TARGET_GNU_CPU)\""
CXXFLAGS += -DCXX_VERSION_LONG="\"$(CXX_VERSION_LONG)\""


ifeq (1,$(shell $(CXX) --version | egrep -c "g\+\+.* [5678]\.[0-9]\.[0-9]"))
# Completing LTO
#LDFLAGS += $(CFLAGS_APPEND)
endif

$(info I: Extended CXXFLAGS: $(CXXFLAGS))
$(info I:          LDFLAGS: $(LDFLAGS))


## Get upstream version from debian version.
#UPSTREAM_VERSION = $(shell dpkg-parsechangelog | egrep '^Version:' | \
#  cut -d ' ' -f 2 | cut -d '-' -f 1 | cut -d '+' -f 1 | cut -d '~' -f 1 | perl -pe 's/^.*?://')
## Remove dot "." in upstream version for use in app_info.xml
##APP_INFO_VERSION = $(subst .,,$(UPSTREAM_VERSION))
# 56 was agreed with upstream
APP_INFO_VERSION = 56


%:
	dh $@
	
override_dh_auto_build: 
ifeq (1,$(shell grep -c "^Package: boinc-app-eah-brp-opencl" debian/control))
	@echo Peforming with Makefile.linux.opencl
	$(MAKE) EINSTEINBINARY_TARGET=$(EINSTEINBINARY_TARGET_OPENCL) -f Makefile.linux.opencl release
endif
	@echo Building with gprof parameters and running example workflow
	$(MAKE) profile
	@echo Compiling with runtime parameters learned
	$(MAKE) release

override_dh_install: 
	cat debian/extra/app_info.xml.in | perl -ne 'print unless /^#/' | \
	  sed -e 's/VERSION/$(APP_INFO_VERSION)/' > debian/extra/app_info.xml
	dh_install --list-missing

override_dh_auto_clean:
	$(MAKE) clean || echo "I: Make clean fails with no patches applied - please ignore"
	dh_clean stderr.old stderr.txt boinc_EinsteinRadio_0 boinc_EinsteinRadio_0 boinc_finish_called
	dh_clean einsteinbinary einsteinbinary_BRP4* einsteinbinary_opencl*
	dh_clean results_profile.cand *.gcda *.o boinc_EinsteinRadio_0 boinc_finish_called
	dh_clean debian/extra/einstein_bench/boinc_EinsteinRadio_0 \
	         debian/extra/einstein_bench/boinc_finish_called \
	         debian/extra/einstein_bench/stderr.txt \
	         debian/extra/einstein_bench/testwu/stochastic_full.bank.*

test:	override_dh_auto_test
override_dh_auto_test:
	$(MAKE) TARGET=$(EINSTEINBINARY_TARGET) test

## boinc-app-eah-brp 0.20170426+dfsg

=== Makefile ===
###########################################################################
#   Copyright (C) 2008 by Oliver Bock                                     #
#   oliver.bock[AT]aei.mpg.de                                             #
#                                                                         #
#   This file is part of Einstein@Home (Radio Pulsar Edition).            #
#                                                                         #
#   Einstein@Home is free software: you can redistribute it and/or modify #
#   it under the terms of the GNU General Public License as published     #
#   by the Free Software Foundation, version 2 of the License.            #
#                                                                         #
#   Einstein@Home is distributed in the hope that it will be useful,      #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with Einstein@Home. If not, see <http://www.gnu.org/licenses/>. #
#                                                                         #
###########################################################################

# path settings
EINSTEIN_RADIO_SRC?=$(PWD)
EINSTEIN_RADIO_INSTALL?=$(PWD)

# config values
CXX ?= g++

# variables
LIBS += -Wl,-Bstatic
LIBS += -L$(EINSTEIN_RADIO_INSTALL)/lib64 -L$(EINSTEIN_RADIO_INSTALL)/lib
LIBS += $(shell $(EINSTEIN_RADIO_INSTALL)/bin/gsl-config --libs)
LIBS += $(shell export PKG_CONFIG_PATH=$(EINSTEIN_RADIO_INSTALL)/lib/pkgconfig && pkg-config --libs fftw3f)
LIBS += $(shell $(EINSTEIN_RADIO_INSTALL)/bin/xml2-config --libs)
LIBS += -lboinc_api -lboinc
LIBS += -lbfd -liberty
LIBS += -L/usr/lib
LIBS += -lstdc++
LIBS += -Wl,-Bdynamic
LIBS += -lpthread -lm -lc
LIBS += $(EINSTEIN_RADIO_INSTALL)/lib/libz.a

LDFLAGS += -static-libgcc

CXXFLAGS += -I$(EINSTEIN_RADIO_INSTALL)/include
CXXFLAGS += $(shell $(EINSTEIN_RADIO_INSTALL)/bin/gsl-config --cflags)
CXXFLAGS += $(shell export PKG_CONFIG_PATH=$(EINSTEIN_RADIO_INSTALL)/lib/pkgconfig && pkg-config --cflags fftw3f)
CXXFLAGS += $(shell $(EINSTEIN_RADIO_INSTALL)/bin/xml2-config --cflags)
CXXFLAGS += -I$(EINSTEIN_RADIO_INSTALL)/include/boinc
CXXFLAGS += -DHAVE_INLINE -DBOINCIFIED
CXXFLAGS += -DUSE_CPU_RESAMP -DUSE_FFTW_FFT

DEPS = Makefile
OBJS = demod_binary.o demod_binary_resamp_cpu.o demod_binary_fft_fftw.o demod_binary_hs_cpu.o rngmed.o erp_boinc_ipc.o erp_getopt.o erp_getopt1.o erp_utilities.o erp_execinfo_plus.o hs_common.o
EINSTEINBINARY_TARGET ?= einsteinbinary
TARGET = $(EINSTEINBINARY_TARGET)

# primary role based tagets
default: release
debug: $(TARGET)
profile: clean $(TARGET)
release: clean $(TARGET)

# target specific options
debug: CXXFLAGS += -DLOGLEVEL=debug -pg -ggdb3 -rdynamic -O0 -Wall
profile: CXXFLAGS += -DNDEBUG -DLOGLEVEL=info -ggdb3 -rdynamic -O3 -Wall -fprofile-generate
release: CXXFLAGS += -DNDEBUG -DLOGLEVEL=info -ggdb3 -rdynamic -O3 -Wall -fprofile-use

# file based targets
profile:
	@echo "Removing previous profiling data..."
	rm -f *_profile.*
	rm -f *.gcda
	@echo "Gathering profiling data (this takes roughly one minute)..."
	./$(TARGET) -t $(EINSTEIN_RADIO_SRC)/../test/templates_400Hz_2_short.bank -l $(EINSTEIN_RADIO_SRC)/data/zaplist_232.txt -A 0.04 -P 3.0 -W -z -i $(EINSTEIN_RADIO_SRC)/../test/J1907+0740_dm_482.binary -c status_profile.cpt -o results_profile.cand
	@echo "Finished gathering profiling data..."

$(TARGET): $(DEPS) $(EINSTEIN_RADIO_SRC)/erp_boinc_wrapper.cpp $(OBJS)
	$(CXX) -g $(CXXFLAGS) $(LDFLAGS) $(EINSTEIN_RADIO_SRC)/erp_boinc_wrapper.cpp -o $(TARGET) $(OBJS) $(LIBS)

demod_binary.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/demod_binary.c $(EINSTEIN_RADIO_SRC)/demod_binary.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/demod_binary.c

demod_binary_resamp_cpu.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/demod_binary_resamp_cpu.c $(EINSTEIN_RADIO_SRC)/demod_binary_resamp_cpu.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/demod_binary_resamp_cpu.c

hs_common.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/hs_common.c $(EINSTEIN_RADIO_SRC)/hs_common.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/hs_common.c

demod_binary_hs_cpu.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/demod_binary_hs_cpu.c $(EINSTEIN_RADIO_SRC)/demod_binary_hs_cpu.h $(EINSTEIN_RADIO_SRC)/hs_common.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/demod_binary_hs_cpu.c

demod_binary_fft_fftw.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/demod_binary_fft_fftw.c $(EINSTEIN_RADIO_SRC)/demod_binary_fft_fftw.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/demod_binary_fft_fftw.c

rngmed.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/rngmed.c $(EINSTEIN_RADIO_SRC)/rngmed.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/rngmed.c

erp_boinc_ipc.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/erp_boinc_ipc.cpp $(EINSTEIN_RADIO_SRC)/erp_boinc_ipc.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/erp_boinc_ipc.cpp

erp_getopt.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/erp_getopt.c $(EINSTEIN_RADIO_SRC)/erp_getopt.h $(EINSTEIN_RADIO_SRC)/erp_getopt_int.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/erp_getopt.c

erp_getopt1.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/erp_getopt1.c $(EINSTEIN_RADIO_SRC)/erp_getopt.h $(EINSTEIN_RADIO_SRC)/erp_getopt_int.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/erp_getopt1.c

erp_utilities.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/erp_utilities.cpp $(EINSTEIN_RADIO_SRC)/erp_utilities.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/erp_utilities.cpp

erp_execinfo_plus.o: $(DEPS) $(EINSTEIN_RADIO_SRC)/erp_execinfo_plus.c $(EINSTEIN_RADIO_SRC)/erp_execinfo_plus.h
	$(CXX) -g $(CXXFLAGS) -c $(EINSTEIN_RADIO_SRC)/erp_execinfo_plus.c

install:
	mkdir -p $(EINSTEIN_RADIO_INSTALL)/../dist
	cp $(TARGET) $(EINSTEIN_RADIO_INSTALL)/../dist

clean:
	rm -f $(OBJS) $(TARGET)

=== debian/changelog ===
boinc-app-eah-brp (0.20170426+dfsg-2build2) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 01:08:19 +0000

boinc-app-eah-brp (0.20170426+dfsg-2build1) artful; urgency=medium

  * No-change rebuild against binutils 2.29

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 29 Jul 2017 10:30:39 -0700

boinc-app-eah-brp (0.20170426+dfsg-2) unstable; urgency=medium

  * Addressed compiler warnings.
  * Initial release (Closes: #861600).
  * Public redistribution as version 0.01 as set in debian/rules

 -- Steffen Moeller <moeller@debian.org>  Thu, 04 May 2017 09:28:07 +0200

boinc-app-eah-brp (0.20170426+dfsg-1) unstable; urgency=medium

  * First internal distribution.

 -- Steffen Moeller <moeller@debian.org>  Wed, 26 Apr 2017 23:44:15 +0200

=== debian/control ===
Source: boinc-app-eah-brp
Section: science
Priority: optional
Maintainer: Debian BOINC Maintainers <pkg-boinc-devel@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>, Christian Dreihsig <christian.dreihsig@t-online.de>
Build-Depends: debhelper (>= 9), libboinc-app-dev, libxml2-dev, libiberty-dev, libgsl-dev|libgsl0-dev, binutils-dev,  libfftw3-dev, pkg-config
Standards-Version: 3.9.8
Homepage: https://einsteinathome.org/application-source-code-and-license
Vcs-Git: https://github.com/VolunteerComputingHelp/boinc-app-eah-brp.git
Vcs-Browser: https://github.com/VolunteerComputingHelp/boinc-app-eah-brp.git

Package: boinc-app-eah-brp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, boinc-client
Recommends: boinc-manager
Suggests: boinc-app-seti
Description: BOINC extension for Einstein at Home binary pulsar search
 BOINC (Berkeley Open Infrastructure for Network Computing) is a volunteer
 project to have regular citizens help with their compute power to address
 large scientific challenges. To contribute, please see the home pages
 of the BOINC project for details and follow the links to the respecitve
 page of the scientific project.
 .
 This package provides an executable for the Binary Pulsar Search
 subproject of the Einstein@Home project. Regular users would
 auto-download that executable via the BOINC-Client application or
 the BOINC-Manager. This package provides the equivalent binary but
 compiled on the Debian build demons. As such it is available to many
 more platforms than what could possibly be provided by the scientists
 themselves. Also, recompiling the package is likely to yield an
 executable well-optimized for the local machine that outperformes
 the official executable.
 .
 Quite some also run the Debian-provided packages for security concerns.
 They already decided to trust the Debian community and appreciated
 that executable to ship with an inspectable source tree.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to compile with gcc-snapshot.
#export  CC=/usr/lib/gcc-snapshot/bin/gcc
#export CXX=/usr/lib/gcc-snapshot/bin/g++
#export CPP=/usr/lib/gcc-snapshot/bin/cpp

# Uncomment for particular version of gcc
#export  CC := gcc-4.7
#export CXX := g++-4.7
#export CPP := cpp-4.7

# Uncomment for clang (llvm)
#export CC  = clang
#export CXX = clang

# Set default flags with dpkg-buildflags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_BUILD_GNU_CPU  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


# PKG = boinc-app-eah-brp

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

export EINSTEIN_RADIO_SRC := $(CURDIR)
export EINSTEINBINARY_TARGET = einsteinbinary_BRP4

# Uncomment this to enable compilation with UltraSPARC specific compiler
# flags. This will most probably increase the application's performance or if
# your are unlucky will break it.
#
#CPUTYPE = $(shell head -1 /proc/cpuinfo | cut -f 2 -d ':' | cut -f 3 -d '\' )
#ifeq (UltraSparc, $(CPUTYPE))
#  CPUSUBTYPE = $(shell head -1 /proc/cpuinfo | cut -f 2 -d ':' | \
#    cut -f 4 -d '\' | cut -f 1 -d '+')
#  CFLAGS += -mcpu=v9
#  CXXFLAGS += -mcpu=v9
#  ifeq (III, $(CPUSUBTYPE))
#    CFLAGS += -mcpu=ultrasparc3
#    CXXFLAGS += -mcpu=ultrasparc3
#  else
#    CFLAGS += -mcpu=ultrasparc
#    CXXFLAGS += -mcpu=ultrasparc
#  endif
#  CFLAGS += -m64
#  CXXFLAGS += -m64
#  DEB_CONFIGURE_EXTRA_FLAGS += --enable-bitness=64
#endif


# Append this to CFLAGS and CXXFLAGS.
CFLAGS_APPEND += -I/usr/include/boinc -I/usr/include/boinc/lib -I/usr/include/boinc/api

ifneq (clang,$(CXX))
CFLAGS_APPEND += -O3
#CFLAGS_APPEND += -mno-avx
#CFLAGS_APPEND += -msse4.2
GCCVERSION=$(shell $(CXX) --version | tr " " "\n" | egrep '^[0-9]+\.[0-9]+\.[0-9]+$$' | cut -f1,2 -d.)
endif

ifeq (clang,$(CXX))
GCCVERSION=$(shell $(CXX) --version | tr " " "\n" | egrep '^[0-9]+\.[0-9]+-[0-9]+$$' | cut -f1 -d-)
CFLAGS_APPEND += -O3
# -O4 implies link-time optimisation with clang, fails
endif

ifeq (linux,$(shell dpkg-architecture -qDEB_TARGET_ARCH_OS))
ifneq (,$(findstring local,$(DEB_BUILD_OPTIONS)))
LOCALOPTIMISATION="yes"
endif
ifeq (,$(shell dpkg-parsechangelog | egrep '^Distribution:' |egrep -v 'UNRELEASED'))
LOCALOPTIMISATION="yes"
endif
endif

#CFLAGS_APPEND += -O3
#CFLAGS_APPEND += -fomit-frame-pointer

# If the package is not meant to be distributed to main servers, then maximise optimisation
ifneq (,$(LOCALOPTIMISATION))
  $(info I: Setting native flags for optimisation)
  CFLAGS_APPEND += -march=native -mtune=native
else
  $(info W: _Not_ setting native flags for optimisation)
ifeq ($(DEB_BUILD_GNU_CPU),i686)
  $(info W: Not supporting earlier systems than i686)
  # Demand i686 class system
  CFLAGS_APPEND += -march=i686 -mcpu=i686
endif
ifeq ($(DEB_BUILD_GNU_CPU),x86_64)
  #CFLAGS_APPEND += -mavx -msse3 
endif
endif

CXXFLAGS += $(CFLAGS_APPEND)
$(info CXXFLAGS $(CXXFLAGS))


# Get upstream version from debian version.
UPSTREAM_VERSION = $(shell dpkg-parsechangelog | egrep '^Version:' | \
  cut -d ' ' -f 2 | cut -d '-' -f 1 | cut -d '+' -f 1 | cut -d '~' -f 1 | perl -pe 's/^.*?://')
# Remove dot "." in upstream version for use in app_info.xml
#APP_INFO_VERSION = $(subst .,,$(UPSTREAM_VERSION))
APP_INFO_VERSION = 1


%:
	dh $@

override_dh_install: 
	cat debian/extra/app_info.xml.in | perl -ne 'print unless /^#/' | \
	  sed -e 's/VERSION/$(APP_INFO_VERSION)/' > debian/extra/app_info.xml
	dh_install --list-missing

override_dh_auto_clean:
	make clean || echo "I: Make clean fails with no patches applied - please ignore"
	dh_clean stderr.old stderr.txt boinc_EinsteinRadio_0 boinc_EinsteinRadio_0 boinc_finish_called
	dh_clean einsteinbinary einsteinbinary_BRP4

=== debian/watch ===
version=4
#opts="pgpsigurlmangle=s%$%.sig%"

# HTTP site (basic)
#http://example.com/downloads.html \
#  files/boinc-app-eah-brp-([\d\.]+)\.tar\.gz debian uupdate

# Uncommment to examine a FTP server
#ftp://ftp.example.com/pub/boinc-app-eah-brp-(.*)\.tar\.gz debian uupdate

# SourceForge hosted projects
# http://sf.net/boinc-app-eah-brp/ boinc-app-eah-brp-(.*)\.tar\.gz debian uupdate

# GitHub hosted projects
#opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
#   https://github.com/<user>/boinc-app-eah-brp/tags \
#   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

# PyPI
# https://pypi.debian.net/boinc-app-eah-brp/boinc-app-eah-brp-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

# Direct Git
# opts="mode=git" http://git.example.com/boinc-app-eah-brp.git \
#   refs/tags/v([\d\.]+) debian uupdate


# Uncomment to find new files on GooglePages
# http://example.googlepages.com/foo.html boinc-app-eah-brp-(.*)\.tar\.gz

https://einstein.phys.uwm.edu/download/brp-src-release.zip
